//
//  TVTableGenerator.h
//  TVPlugin
//
//  Created by Takaho A. Endo on 05/07/15.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "AreaProgram.h"

//
// Plugin interface
//
@interface TVTableGenerator : NSObject {
	NSString* CSVFilename;
	AreaProgram* areaTable;
}

// initializer
-(TVTableGenerator*)initWithWebView: (WebView*)view;

// destructor
-(void)dealloc;

// scripting interface
-(void)windowScriptObjectAvailable:(WebScriptObject*)wso;
+(NSString*)webScriptNameForSelector:(SEL)aSel;

// accessors to selectors
+(BOOL)isSelectorExcludedFromWebScript:(SEL)aSel;
+(BOOL)isKeyExcludedFromWebScript:(const char*)k;


// set programs and instanciate an AreaProgram object
-(void)setProgramFile: (NSString*)filename;
// remove CSV file, this method is used for removing cache file because JavaScript 
// is not allowed to touch files.
-(void)removeProgramFile: (NSString*)filename;
// get filename
-(NSString*)getProgramFile;

// name of area (prefecture)
-(NSString*)getArea;

// retrieve programs in time range
-(NSString*)getProgramListWithRange : (NSString*) format channel:(int)number start:(int)startMinutes	end:(int)endMinutes;	
// data accessors
-(int)getChannelSize; // the number of channels
// name of channel
-(NSString*)getChannelName : (int)num;
// current programs in line-separated text
-(NSString*)getCurrentPrograms: (int) minutes; 

// debug
-(void)log : (NSString*) message;

@end
